/* KallistiGL for KOS 1.1.3

   glkos.c
   (c)2001 Dan Potter
*/

static char id[] = "KGL $Id: glkos.c,v 1.1 2001/09/09 23:58:36 bard Exp $";

#include <dc/video.h>
#include <dcutils/pvrutils.h>
#include <stdio.h>
#include <string.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include "glinternal.h"

/* KOS-specific APIs */

int glKosInit() {
	GLfloat w, h;
	
	/* Pre-initialize all the globals */
	gl_clear_color[0] =
		gl_clear_color[1] =
		gl_clear_color[2] =
		gl_clear_color[3] = 0.0f;
	gl_capabilities = 0;
	gl_prim_type = 0;
	gl_pbuf_submitted = GL_FALSE;

	/* Reset all matrices */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glMatrixMode(GL_TEXTURE);
	glLoadIdentity();

	/* Setup some basic polygon headers */
	ta_poly_hdr_col(&gl_pbuf_col_opaque, TA_OPAQUE);
	ta_poly_hdr_col(&gl_pbuf_col_trans, TA_TRANSLUCENT);
	gl_pbuf = &gl_pbuf_col_opaque;

	/* Initialize the viewport */
	glKosGetScreenSize(&w, &h);
	glViewPort(0, 0, (GLsizei)w, (GLsizei)h);

	return 0;
}

void glKosShutdown() {
}

void glKosGetScreenSize(GLfloat *w, GLfloat *h) {
	switch(vid_resolution) {
	case DM_320x240:
		*w = 320.0f; *h = 240.0f; break;
	case DM_640x480:
		*w = 640.0f; *h = 480.0f; break;
	case DM_800x608:
		*w = 800.0f; *h = 608.0f; break;
	default:
		dbglog(DBG_DEBUG, "gl: invalid screen resolution id\n");
	}
}

void glKosBeginFrame() {
	ta_begin_render();
	gl_pbuf_submitted = GL_FALSE;
}

void glKosFinishFrame() {
	ta_commit_eol();
	pvr_dummy_poly(TA_TRANSLUCENT);
	ta_commit_eol();
	ta_finish_frame();
}

